from report import report_sxw
from numero_a_texto import Numero_a_Texto

class rep_invoice(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(rep_invoice, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'sum_qty':self.sum_qty,
            'numero_en_letras': self.obt_texto,
            'get_user_name': self.get_user_name,
        })
        self.context = context
        
    def sum_qty(self,invoice_id):
        self.cr.execute("select sum(quantity) from account_invoice_line where invoice_id =%s ", (invoice_id,))
        res = self.cr.fetchone()
        return res[0]

    def obt_texto(self, amount):
        return  Numero_a_Texto(str(amount))

    def get_salesman_code(self, user_id):
        emp_obj = self.pool.get('hr.employee')
        employee_id = emp_obj.search(cr, uid, [('user_id', '=', user_id)])
        return semp_obj.browse(cr, uid, employee_id).user_id or ''
        
    def get_user_name(self, invoice_id, type_doc):
        
        nombre = '***'
        
        if invoice_id:
            
            if type_doc == 'realizado':
                qry = """
                    select ru.name as nombre
                    from account_invoice ai
                    inner join res_users ru on ai.create_uid = ru.id
                    where ai.id = %s
                    """%(invoice_id)
                    
                self.cr.execute(qry)
                nombre = self.cr.dictfetchone()
                nombre = nombre['nombre']
            else:
                print 'autorizado'
                ai_obj = self.pool.get('account.invoice')
                list_sale_order = ai_obj.browse(self.cr, self.uid, invoice_id).sale_ids
                print 'list_sale_order',list_sale_order
                if list_sale_order:
                    nombre = list_sale_order[0].shop_id.autorizador and list_sale_order[0].shop_id.autorizador.name or '***'
        
        return nombre

report_sxw.report_sxw(
    'report.sisb.invoice',
    'account.invoice',
    'sisb_ventas/report/invoice.rml',
    parser=rep_invoice, header=False
)
